<html ng-app="testClient">
<head>
	<meta charset="UTF-8">
	<title>Test Client</title>
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css">	
	<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.5.8/angular.min.js"></script>
	<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.5.8/angular-cookies.js"></script>
	<script>	
		var app = angular.module('testClient', ['ngCookies']);		
		
		app.config(['$httpProvider', function ($httpProvider) {
			$httpProvider.defaults.useXDomain = true;
			delete $httpProvider.defaults.headers.common['X-Requested-With'];			
		}]);
		
		app.controller("MainCtl", ["$scope", "$cookies", "$http", "$interval",
		function($scope, $cookies, $http, $interval) {
			$scope.messages = [];			
		
			var account = $cookies.get('myAccount');
			
			var isLogin = false;
			var stop;
			
			$scope.click = function() {
				$scope.name = $scope.User.Name;
				$scope.show = false;
				$cookies.put('myAccount', $scope.name);
				$scope.messages.push("Signed in as '" + $scope.name + "'");
				
				isLogin = true;
				$scope.startSending();
			};
			
			$scope.startSending = function() {
				if ( angular.isDefined(stop) ) return;
				
				stop = $interval(function() {									
						if (!isLogin) return;												
						if (!navigator.geolocation)						
						{
							$scope.messages.push('geolocation services are not supported by your browser')
							return;
						}							
						navigator.geolocation.getCurrentPosition($scope.sendGeolocation);						
					}, 5000);
			};
			$scope.stopSending = function() {
				if (angular.isDefined(stop)) {
					$interval.cancel(stop);
					stop = undefined;
				}
			};
			$scope.sendGeolocation = function(position) {				
				var dataObj = {
							user : $scope.name,
							latitude : position.coords.latitude,
							longitude : position.coords.longitude
						};
				var parameter = JSON.stringify(dataObj);
				$http.post('http://localhost:8080/update_user_geolocation', parameter, {
					headers: { 'Content-Type': 'application/json; charset=UTF-8'}
				})
				.success(function(data, status, headers, config) {
					$scope.messages.push("update success: [" + parameter + "]");
				})
				.error(function(data, status, headers, config) {
					$scope.messages.push("failure message: " + JSON.stringify({data: data}) + " / param : [" + parameter + "]");
				});
			};
			
			$scope.$on('$destroy', function() {
			  // Make sure that the interval is destroyed too
			  $scope.stopSending();
			});			
			
			if (account)
			{
				$scope.name = account;
				$scope.show = false;
				$scope.messages.push("Signed in as '" + $scope.name + "'");
				isLogin = true;
				$scope.startSending();
			}
			else
			{
				$scope.name = "";
				$scope.show = true;
				$scope.messages.push("Please register for an account.");
				$scope.messages.push("If you've already registered, please enter your account.");
			}					
			
		}]);
	</script>
	<style>
	#logs {
			height: 500px;
			overflow: scroll;
	}
	</style>
</head>
<body ng-controller="MainCtl">
	<div>
		<h1>Hello! {{ name }}</h1>
	</div>
	<div ng-show="show">
		<input type="text" placeholder="Enter your ID" ng-model="User.Name" ng-enter="click()"/>
		<button class="btn btn-primary" ng-click="click()">Sign In</button>
	</div>
	<br><br>
	<div id="logs">
		<ul>
			<li ng-repeat="m in messages track by $index">{{ m }}</li>
		</ul>
	</div>
</body>
</html>
